%module fotometry

%include typemaps.i

%{
#include "cbind.h"
#include "arrayobject.h"
#define PY_ARRAY_UNIQUE_SYMBOL
%}

/*--------------------------*/

%typemap(python,arginit) const float *IMAGE (long na[10]) {
    import_array();
    na[0] = 0;
}

%typemap(python,in) const float *IMAGE {
   PyArrayObject *array;
   PyArrayObject *o;
   PyArrayObject *a;
   na[0] += 1;
   o = (PyArrayObject *) $source;
   _arg1 = o->dimensions[1];
   _arg2 = o->dimensions[0];
   a = (PyArrayObject *) PyArray_ContiguousFromObject( $source, (o->descr)->type, 0, 0);
   array= (PyArrayObject *) PyArray_Cast( a, PyArray_FLOAT);
   $target = (float *) ( array->data);
   na[na[0]] = (long ) array;
   Py_DECREF(a);
}

%typemap(python,argout) const float *IMAGE {
   int j;
   PyArrayObject *a;
   if (na[0] > 0) {
     for (j=1;j<=na[0];j++) {
       a = (PyArrayObject *) na[j];
       Py_DECREF(a);
     }
   }
   na[0] = 0;
}

/*--------------------------*/

%typemap(python,in) const float *PARARRAY {
   PyArrayObject *array;
   PyArrayObject *o;
   PyArrayObject *a;
   na[0] += 1;
   o = (PyArrayObject *) $source;
   _arg4 = o->dimensions[0] - 2;
   a = (PyArrayObject *)
       PyArray_ContiguousFromObject( $source, o->descr->type, 0, 0);
   array= (PyArrayObject *) PyArray_Cast( a, PyArray_FLOAT);
   $target = (float *) ( array->data);
   na[na[0]] = (long ) array;
   Py_DECREF(a);
}

%typemap(python,argout) const float *PARARRAY {
   int j;
   PyArrayObject *a;
   if (na[0] > 0) {
     for (j=1;j<=na[0];j++) {
       a = (PyArrayObject *) na[j];
       Py_DECREF(a);
     }
   }
   na[0] = 0;
}

/*--------------------------*/

%typemap(python,in) const float *ARRAY {
   PyArrayObject *array;
   PyArrayObject *o;
   PyArrayObject *a;
   na[0] += 1;
   o = (PyArrayObject *) $source;
   _arg9 = o->dimensions[0];
   a = (PyArrayObject *)
       PyArray_ContiguousFromObject( $source, o->descr->type, 0, 0);
   array= (PyArrayObject *) PyArray_Cast( a, 'f');
   $target = (float *) ( array->data);
   na[na[0]] = (long ) array;
   Py_DECREF(a);
}

%typemap(python,argout) const float *ARRAY {
   int j;
   PyArrayObject *a;
   if (na[0] > 0) {
     for (j=1;j<=na[0];j++) {
       a = (PyArrayObject *) na[j];
       Py_DECREF(a);
     }
   }
   na[0] = 0;
}

/*--------------------------*/

%typemap(python,ignore) float *APMAGS  (PyArrayObject * apmags) {
    import_array();
}

%typemap(python,check) float *APMAGS {
    npy_intp *naxes;
    int i,ns;
    int naxis = 2;
    int ArrayType;
    naxes = (npy_intp *) malloc((naxis+1)*sizeof(npy_intp));
    naxes[0] = _arg4;
    naxes[1] = _arg9;
    ArrayType=PyArray_FLOAT;
    apmags = (PyObject *) PyArray_SimpleNew(naxis,naxes, ArrayType);
    $target = ($type ) ( (PyArrayObject *) apmags)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *APMAGS {
    $target = t_output_helper($target, (PyObject *) apmags);
}


/*--------------------------*/

%typemap(python,ignore) float *APERRS  (PyArrayObject * aperrs) {
    import_array();
}

%typemap(python,check) float *APERRS {
    npy_intp *naxes;
    int i,ns;
    int naxis = 2;
    int ArrayType;
    naxes = (npy_intp *) malloc((naxis+1)*sizeof(npy_intp));
    naxes[0] = _arg4;
    naxes[1] = _arg9;
    ArrayType=PyArray_FLOAT;
    aperrs = (PyObject *) PyArray_SimpleNew(naxis,naxes, ArrayType);
    $target = ($type ) ( (PyArrayObject *) aperrs)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *APERRS {
    $target = t_output_helper($target, (PyObject *) aperrs);
}


/*--------------------------*/

%typemap(python,ignore) float *SKYS  (PyArrayObject * SKYS) {
    import_array();
}

%typemap(python,check) float *SKYS {
    npy_intp *naxes;
    int i,ns;
    int naxis = 1;
    int ArrayType;
    naxes = (npy_intp *) malloc((naxis+1)*sizeof(npy_intp));
    naxes[0] = _arg9;
    ArrayType=PyArray_FLOAT;
    SKYS = (PyObject *) PyArray_SimpleNew(naxis,naxes, ArrayType);
    $target = ($type ) ( (PyArrayObject *) SKYS)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *SKYS {
    $target = t_output_helper($target, (PyObject *) SKYS);
}



/*--------------------------*/

%typemap(python,ignore) float *SIGS  (PyArrayObject * SIGS) {
    import_array();
}

%typemap(python,check) float *SIGS {
    npy_intp *naxes;
    int i,ns;
    int naxis = 1;
    int ArrayType;
    naxes = (npy_intp*) malloc((naxis+1)*sizeof(npy_intp));
    naxes[0] = _arg9;
    ArrayType=PyArray_FLOAT;
    SIGS = (PyObject *) PyArray_SimpleNew(naxis,naxes, ArrayType);
    $target = ($type ) ( (PyArrayObject *) SIGS)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *SIGS {
    $target = t_output_helper($target, (PyObject *) SIGS);
}


/*--------------------------*/

%typemap(python,ignore) float *SKWS  (PyArrayObject * SKWS) {
    import_array();
}

%typemap(python,check) float *SKWS {
    npy_intp *naxes;
    int i,ns;
    int naxis = 1;
    int ArrayType;
    naxes = (npy_intp *) malloc((naxis+1)*sizeof(npy_intp));
    naxes[0] = _arg9;
    ArrayType=PyArray_FLOAT;
    SKWS = (PyObject *) PyArray_SimpleNew(naxis,naxes, ArrayType);
    $target = ($type ) ( (PyArrayObject *) SKWS)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *SKWS {
    $target = t_output_helper($target, (PyObject *) SKWS);
}

/*--------------------------*/

%typemap(python,ignore) int nrow (int ftemp) {
   ftemp = 0;
}

%typemap(python,ignore) int ncol (int gtemp) {
   gtemp = 0;
}

%typemap(python,ignore) int maxap (int htemp) {
   htemp = 0;
}

%typemap(python,ignore) int maxstars (int itemp) {
   itemp = 0;
}


typedef int Logical;

void foto(const float *IMAGE, int ncol, int nrow,
const float *PARARRAY,
int maxap,float lobad, float hibad, float phpadu, float readns,
int maxstars, const float *ARRAY, const float *ARRAY,
Logical var, float watch, float *APMAGS, float *APERRS,
float *SKYS, float *SIGS, float *SKWS);


